<?php
echo "ESTE SCRIPT É PERIGOSO, FAVOR USAR COM CAUTELA";
die();
global $html;
$html = "";

function verificar_existe_proxima_parcela($sequencia, $total, $idvenda){
	global $html;
	include "conexao.php";

	if($sequencia == $total){
		$sequencia = $total;
		$total = $total + 12;
	}


	$parcelas_qf = array();
	while( $sequencia < $total ){

		$sequencia = $sequencia + 1;

		if($sequencia < 10 ){
			$s = '00'.$sequencia;
		}else if($sequencia >= 10 AND $sequencia < 100){
			$s = '0'.$sequencia;
		}else{
			$s = $sequencia;
		}

		if($total < 10 ){
			$t = '00'.$total;
		}else if($total >= 10 AND $total < 100){
			$t = '0'.$total;
		}else{
			$t = $total;
		}

		$parcelas_qf[] = $mountar_sequencia = $s."/".$t;
               // $html .= "PROXIMA PARCELA  .: " . $mountar_sequencia . "<br>";

	}

	$existe = array();

	foreach ($parcelas_qf as  $parc) {
             	# code...
		$query = "SELECT COUNT(*) as existe_parcela FROM parcelas WHERE venda_idvenda = '$idvenda' and numero_sequencia = '$parc' ";

                  // $html .= $query;

		$executa = mysqli_query($db,$query) or die ("erro ao selecionar parcelas restantes");

		$buscar_amigo = mysqli_fetch_assoc($executa) or die ("erro ao executar fetch assoc");

		$existe[] =  $buscar_amigo['existe_parcela'];


	}

	if(in_array("1", $existe)){
		$html .= "CONTRATO ATIVO  .: " . $idvenda . "<br>";

	}else if(in_array("0", $existe)){

		$html .= "CONTRATO POSSIVELMENTE FINALIZADO  .: " . $idvenda . "<br>";

	}


	$cont =0;
	foreach ($existe as $ex) {
		if($ex == 0){
			$html .= "PROXIMA PARCELA  .: " . $parcelas_qf[$cont]. "  Nao existe<br>";	
		}else if($ex == 1){
			$html .= "PROXIMA PARCELA  .: " . $parcelas_qf[$cont]. "   existe sim<br> ";

		}
		$cont++;
	}




	$ret = array_unique($existe);

	// $html .= "<pre>";
	// print_r($existe);
	// $html .= "</pre>";



	if (count($ret) == 1){
		if(in_array("1", $existe)){
			return 1;
		}else{
			return 0;
		}


	}else{

		return 1;
	}




}






include "conexao.php";


//pegar todas as vendas ativas
//$query = "SELECT idvenda, plano_pagamento, valor_parcela_financiamento FROM venda where status_venda = 3 AND idvenda = 42 ";

	$query = "SELECT idvenda, plano_pagamento, valor_parcela_financiamento FROM venda where status_venda = 3";


$executa = mysqli_query($db,$query);

$pulo = [12,24,36,48,60,72,84,96,108,120,132,144,156,168,180,192,200];
//print_r($pulo); die();

while($buscar_amigo = mysqli_fetch_assoc($executa)){
	$idvenda = $buscar_amigo['idvenda'];
	//plano de pagamento ex (200)
	$plano = (int)  $buscar_amigo['plano_pagamento'];




	$html .= "<br><strong>VENDA N.: " . $idvenda . "</strong><br>PLANO DE PAGAMENTO .: " . $plano ."<br>" ;

    //para cada venda pegar a ultima parcela paga 

	//$query2 = "SELECT valor_parcelas, data_vencimento_parcela, empreendimento_id_novo, numero_sequencia, cliente_id_novo FROM parcelas WHERE venda_idvenda = '$idvenda' AND situacao = 'PAGO'  ORDER BY venda_idvenda DESC LIMIT 1";


	$query2 = "SELECT venda_idvenda, valor_parcelas, data_vencimento_parcela, empreendimento_id_novo, numero_sequencia, cliente_id_novo FROM parcelas WHERE venda_idvenda = '$idvenda' AND situacao = 'PAGO' AND fluxo = 0 AND ( numero_sequencia not like '%/001' AND numero_sequencia not like '%/002' AND numero_sequencia not like '%/003' AND numero_sequencia not like '%/004' AND numero_sequencia not like '%/005'  AND numero_sequencia not like '%/006'  AND numero_sequencia not like '%/007'  AND numero_sequencia not like '%/008'  AND numero_sequencia not like '%/009'  AND numero_sequencia not like '%/010'  AND numero_sequencia not like '%/011' AND numero_sequencia not like 'A%' AND numero_sequencia not like 'R%' )  ORDER BY idparcelas DESC LIMIT 1";


	//echo  $query2;

	$executa2 = mysqli_query($db, $query2) or die("erro ao executar a query");

	if($buscar_amigo2 = mysqli_fetch_assoc($executa2)){

		$numero_sequencia            = $buscar_amigo2['numero_sequencia'];
		$html .= "ULTIMA PARCELA PAGA .: " . $numero_sequencia . "<br>";

        //pegar o numero sequencia e quebra em dois ex  010/012

		$separa                      = explode("/", $numero_sequencia);


		$data_vencimento_parcela     = $buscar_amigo2['data_vencimento_parcela'];


		$valor_parcelas = $buscar_amigo2['valor_parcelas'];


		$empreendimento_id_novo      = $buscar_amigo2['empreendimento_id_novo'];
		$cliente_id_novo_receber     = $buscar_amigo2['cliente_id_novo'];
		//recebe ex 010  com o int retira o 0 ficando 10
		$sequencia_parada = (int) $separa[0];
        //recebe ex 012  com o int retira o 0 ficando 12
		$lancado_total       = (int) $separa[1];


		if(!in_array($lancado_total, $pulo)){

			$html .= "CONTRATO COM PLANO MENOR QUE 49 PARCELAS <strong> OU </strong> FORA DE SEQUENCIA";
			$html .= "<br><strong>VERIFICAR ESTE CONTRATO !!!! .: " . $idvenda . " </strong><br>";

            continue;

		}




		//acertar data para sincronizaçao
		$acerta = $lancado_total - $sequencia_parada;

		if($acerta > 0){

			$data_vencimento_parcela = date('d-m-Y', strtotime("+".$acerta."month",strtotime($data_vencimento_parcela)));

		}


        //aqui eu anulo as pancelas que chegam 001/001
		$pega_existe = verificar_existe_proxima_parcela($sequencia_parada, $lancado_total, $idvenda);

		if($pega_existe == 0 ){
			$html .= "NADA A FAZER.: <br>";
			$html .= "ULTIMA PARCELA PAGA .: " . $sequencia_parada."/".$lancado_total . "<br>NAO HAVIA PARCELAS GERADAS MANUALMENTE<br>";
			$html .= "<strong>VERIFICAR ESSE CONTRATO SE JA ESTA CONCLUIDO !!!! .: " . $idvenda . " </strong><br>";

			continue;
		}
		if( $plano >= 50){


           //ex:   12             200
			if($plano > 50){
             //ex:  13 
				if($lancado_total == $sequencia_parada){

					if($pega_existe == 1){

						$proxima = ($lancado_total+12) +1;
						$total = $lancado_total + 24;
						$avanca_data = 12; 

						$data_vencimento_parcela = date('d-m-Y', strtotime("+".$avanca_data."month",strtotime($data_vencimento_parcela)));
					}

				}else{
					$proxima = $lancado_total+1;
					$total = $lancado_total + 12; 
				}

				$html .= "PROXIMA PARCELA A SER LANÇADA .: " . $proxima . "<br>";
				$html .= "PROXIMA NUM TOTAL DE .: " . $total . "<br>";
				$html .= "<strong>COMPLETADO COM SUCESSO !!!! .: " . $idvenda . " <strong><br>";

			}
		}else if($sequencia_parada == $plano){  
			$html .= "<br>";
			$html .= "=============================================<br>";
			$html .= "CONTRATO ---->>> JA ESTAVA COMPLETADO <<<---- .: " . $idvenda .   "<br>";
			$html .= "=============================================<br>";
			continue;

		}else{
			$html .= "<br>";
			$html .= "PLANOS MENORES QUE 49";
			$html .= "=============================================<br>";
			$html .= "CONTRATO NAO COMPLETADO .: " . $idvenda .   "<br>";
			$html .= "=============================================<br>";
			continue;
		}

            //usara para avançar os meses data_vencimento das parcelas

		$cont = 1;


		while( $total <= $plano) {

           // if($total == $plano){
           // 	 break;
           // }


			for($w=$proxima; $w <= $total; $w++){
            //completa com zeros 
				if($w < 10 ){
					$p = '00'.$w;
				}else if($w >= 10 AND $w < 100){
					$p = '0'.$w;
				}else{
					$p = $w;
				}

				if($total < 10 ){
					$f = '00'.$total;
				}else if($total >= 10 AND $total < 100){
					$f = '0'.$total;
				}else{
					$f = $total;
				}

					//$html .= "COMPLETANDO CONTRATO  <strong>" . $idvenda  . " </strong> .: " . $p."/".$f . "<br>";

                //cont começa com 1 e vai passando os meses seguintes
				$data_vencimento_parcela = date('d-m-Y', strtotime("+".$cont."month",strtotime($data_vencimento_parcela)));

				$inserir = mysqli_query($db,"INSERT INTO parcelas (
					venda_idvenda,
					valor_parcelas,
					data_vencimento_parcela,
					situacao,
					descricao,
					tipo_venda,
					fluxo,
					cliente_id_novo,
					empreendimento_id_novo,
					centrocusto_id,
					numero_sequencia)

					values (
					'$idvenda',
					'$valor_parcelas',
					'$data_vencimento_parcela',
					'Em Aberto',
					'Financiamento',
					'2',
					'0',
					'$cliente_id_novo_receber',
					'$empreendimento_id_novo',
					'1',
					'$p/$f'

					)

					");
					



				//$cont++;

               ##FIM COMPLETA PARCELAS

				}

				if($total == $plano){
					break;
				}

		//apos termino do form incremente 12 , cada for ira ir de 12 em 12
				$proxima = $proxima + 12;
				$total = $total + 12;
         //se parcela adicionada ultrapassa o plano
		  //sera travada aqui para ficar 200/200

				if($total > $plano){
					$total = $plano;
				}



			}
		}

	}

	echo $html;

	?>

	<script type="text/javascript">print()</script>		
	
